# -*- coding: UTF-8 -*-
import urllib2
import xml.etree.ElementTree as ET
import re
import sys
from mainform_ui import Ui_MainWindow as ui
from PyQt4 import QtCore, QtGui

def XmlForYandexXml(keyword):
    # создаем документ
    root = ET.Element("request") # рутовый элемент <request>
    query = ET.SubElement(root, "query")
    query.text = keyword
    page = ET.SubElement(root, "page")
    page.text = "0"
    groupings = ET.SubElement(root, "groupings")
    groupby = ET.SubElement(groupings, "groupby")
    groupby.set("attr","d") # устанавливаем аттрибуты
    groupby.set("mode","deep")
    groupby.set("groups-on-page","1")
    groupby.set("docs-in-group","0")
    message = ET.tostring(root, 'utf-8') # формируем XML документ
    doc = '<?xml version="1.0" encoding="UTF-8"?>' + message # Добавляем строчку кодировки
    return doc

def YandexRequest(region,user,key,keyword):
    url = "http://xmlsearch.yandex.ru/xmlsearch?user=%s&key=%s" % (user, key)
    UrlRequest = "%s&lr=%s" % (url, region) #формируем строку url + регион
    XmlDoc = XmlForYandexXml(keyword) # формируем нужный xml документ для запроса
    requestXml = urllib2.Request(UrlRequest, XmlDoc) # подготавливаем данные для запроса
    data = urllib2.urlopen(requestXml) #производим сам запрос к Яндексу
    return data.read() # читаем возвращенные данные

# Главное окно программы и его методы
class MainWindow(QtGui.QMainWindow):
    def __init__(self, parent=None):
        QtGui.QWidget.__init__(self, parent)
        self.ui = ui()
        self.ui.setupUi(self)

    def start(self, region, user, key):
        self.ui.textEditOKLinks.clear()
        self.ui.textEditBadLinks.clear()
             
        lines = self.ui.textEditAllLinks.toPlainText()
        
        if not lines.isEmpty():
            for line in lines.split("\n"):
                keyword = str(line)
                badlink = keyword #сохраним кейворд, если ничего не найдем в xml'е

                rq = YandexRequest(region, user, key, keyword) #Составляем запрос и получаем ответ

#                rq = """<?xml version="1.0" encoding="utf-8"?>
#<yandexsearch version="1.0"><request><query>www.video-cod.ru</query><page>0</page><sortby order="descending" priority="no">rlv</sortby><maxpassages></maxpassages><groupings><groupby attr="d" mode="deep" groups-on-page="3" docs-in-group="1" curcateg="-1" /></groupings></request><response date="20120605T022251"><reqid>1338862971696449-1058578276615769231381359-ws35-991-XML</reqid><wordstat>ban: 0,cod: 92973852,ru: 6369190047,video: 5174489845,www: 8504521554</wordstat><found priority="phrase">7412</found><found priority="strict">7412</found><found priority="all">7412</found><found-human>Нашлось 7412 ответов</found-human><results><grouping attr="d" mode="deep" groups-on-page="3" docs-in-group="1" curcateg="-1"><found priority="phrase">524</found><found priority="strict">524</found><found priority="all">524</found><found-docs priority="phrase">1998</found-docs><found-docs priority="strict">1998</found-docs><found-docs priority="all">1998</found-docs><found-docs-human>нашёл 1998 ответов</found-docs-human><page first="1" last="3">0</page><group><categ attr="d" name="video-cod.ru" /><doccount>25</doccount><relevance priority="phrase" /><doc id="75-22-11-Z05D4E38F7B85F3CC"><relevance priority="phrase" /><url>http://www.video-cod.ru/</url><domain>www.video-cod.ru</domain><title>Студия видеомонтажа | видеомонтаж, видеомонтаж свадьбы, монтаж...</title><modtime>20080704T040000</modtime><size>8345</size><charset>utf-8</charset><passages><passage><hlword>www</hlword>.<hlword>video</hlword>-<hlword>cod</hlword>.<hlword>ru</hlword>.</passage></passages><properties><_PassagesType>0</_PassagesType><lang>ru</lang></properties><mime-type>text/html</mime-type><saved-copy-url>http://hghltd.yandex.net/yandbtm?text=www.video-cod.ru&amp;url=http%3A%2F%2Fwww.video-cod.ru%2F&amp;fmode=inject&amp;mime=html&amp;l10n=ru&amp;sign=84f51cd5da2fe4c9d0c696f550382b50&amp;keyno=0</saved-copy-url></doc></group><group><categ attr="d" name="cod.ru" /><doccount>314</doccount><relevance priority="phrase" /><doc id="75-22-35-Z3ED5CDEDCE175DDC"><relevance priority="phrase" /><url>http://video.cod.ru/</url><domain>video.cod.ru</domain><title>VideoCOD </title><modtime>20081110T030000</modtime><size>4038</size><charset>utf-8</charset><passages><passage>Онлайн медиаресурс <hlword>www</hlword>.<hlword>video</hlword>.<hlword>cod</hlword>.<hlword>ru</hlword>.</passage></passages><properties><_PassagesType>1</_PassagesType><lang>ru</lang></properties><mime-type>text/html</mime-type><saved-copy-url>http://hghltd.yandex.net/yandbtm?text=www.video-cod.ru&amp;url=http%3A%2F%2Fvideo.cod.ru%2F&amp;fmode=inject&amp;mime=html&amp;l10n=ru&amp;sign=b84ce4d82ba004dcaf93e1415233dd25&amp;keyno=0</saved-copy-url></doc></group><group><categ attr="d" name="www.vladivostok.ru" /><doccount>7</doccount><relevance priority="all" /><doc id="75-15-8-ZEA25FE860D2CEB8A"><relevance priority="all" /><url>http://www.vladivostok.ru/forum4/</url><domain>www.vladivostok.ru</domain><title>Информация • Vladivostok.<hlword>Ru</hlword> 2.0</title><modtime>20060724T032459</modtime><size>3687</size><charset>utf-8</charset><passages><passage>Городские Форумы. Пропустить. Расширенный поиск. Список форумов. Изменить размер шрифта.</passage></passages><properties><_PassagesType>0</_PassagesType><lang>ru</lang></properties><mime-type>text/html</mime-type><saved-copy-url>http://hghltd.yandex.net/yandbtm?text=www.video-cod.ru&amp;url=http%3A%2F%2Fwww.vladivostok.ru%2Fforum4%2F&amp;fmode=inject&amp;mime=html&amp;l10n=ru&amp;sign=3d7471b15259b24aa789cf407947ffdf&amp;keyno=0</saved-copy-url></doc></group></grouping></results></response></yandexsearch>"""
                
                needsearch = True

                #обработка наличия http://www. в начале урла в запросе
                if keyword.find('http://') == -1 and keyword.find('www.') != -1:        #www.video-cod.ru
                    keyword = '<url>http://' + keyword      
                elif keyword.find('http://') != -1 and keyword.find('www.') == -1:      #http://video-cod.ru
                    keyword = '<url>http://www.' + keyword.split('http://')[1]
                elif keyword.find('http://www.') != -1:                                 #http://www.video-cod.ru
                    keyword = '<url>' + keyword
                else:
                    #needsearch = False
                    keyword = '<url>http://www.' + keyword

                if needsearch:
                    match = re.search(keyword, rq)  #сравнение с помощью модуля регулярных выражений работает быстрее
                    if match:
                        result = match.group().replace('<url>','')
                        self.ui.textEditOKLinks.append(result)
                    else:
                        self.ui.textEditBadLinks.append(badlink)    
                else:
                    self.ui.textEditBadLinks.append(badlink)

    def save(self, filename):
        global region
        global user
        global key

        newuser = self.ui.lineEditUser.text()
        newkey = self.ui.lineEditKey.text()     
        with open(filename, 'wt') as f:
            f.write("213\n")
            f.write("%s\n"%newuser)
            f.write("%s\n"%newkey)        
        user = newuser
        key = newkey

    def load(self, filename):
        f = open(filename, "rU")
        lines = f.readlines()
        lines = [s.strip() for s in lines] #убираем \n
        return lines
    
if __name__ == "__main__":
    sys.stdout = open("log.txt", "a+")
    sys.stderr = open("errors.txt", "a+") 

    filename = "settings.txt"
    region = ''
    user = ''
    key = ''
    app = QtGui.QApplication(sys.argv)
    mainapp = MainWindow()
    mainapp.ui.textEditAllLinks.append("""www.video-cod.ru\nhttp://video-cod.ru\nhttp://www.video-cod.ru\nvideo-cod.ru""")
    lines = mainapp.load(filename)

    if len(lines) > 2:
        region = lines[0]
        user = lines[1]
        key = lines[2]
    else:
        print('Cannot read settings from %s'%filename)
        sys.exit(-1)

    mainapp.ui.lineEditUser.setText(user)
    mainapp.ui.lineEditKey.setText(key)  
    #кнопко старт
    mainapp.ui.pushButtonStart.clicked.connect(lambda: mainapp.start(region, user, key))
    #кнопко выход
    mainapp.ui.pushButtonExit.clicked.connect(lambda: mainapp.close())
    #кнопко саве
    mainapp.ui.pushButtonSave.clicked.connect(lambda: mainapp.save(filename))
    #максимизируем главное окно
    mainapp.showMaximized()

    sys.exit(app.exec_())
